
;*************   ******************************
;*
;*  AVR ATtiny13A,   9,6 
;*  I2C,   100  
;*  SPI,     
;* ; 
;*
;* Main:   
;* Timer_Int0:     0,  
;* WrData164:     0   164
;* Read_SPI:         
;* SYMBOL:           
;* ConvSegm:          
;* Code_8:             
;* 
;* FUSES;          ()
;*************************************************************************

.nolist
.include "tn13def.inc"
.list

;*****  *****

.def	Save = r12     ;   SREG  
.def    Cnt2 = r15     ;  2   
.def	t1	 = r16     ;   
.def	t2	 = r17     ;   
.def	dbyt = r18     ;       I2C
.def	Flg =  r19     ;  
.def	DPtr = r20     ;    
.def    t3 = r21       ;   
.def	Cnt1  = r22    ;  1   
.def	Byte_SPI = r23 ;    SPI
.def	time = r24     ;   
.def    Cnt = r25      ;    
             

;*****   *****

.equ	Interval= 163   ;    T0,  400 
.equ    SDI = PB0       ; SDI =  B,  SPI
.equ    SCK = PB1       ; SCK =  B
.equ    SCL = PB3       ; SCL =  B,  I2C
.equ    SDA = PB4       ; SDA =  B
.equ    Nbyte = 6       ;    
.equ  PCF_Adr = $40     ;  PCF8574T/3

;    Flg:
.equ	Ack   = 0	;   =  0

.cseg

.org 0
	rjmp Initial
  
.org 3                   ;    T0, 
	rjmp Timer_Int0      
    
Initial:	
	
	ldi	t1,(RAMEND)	    ;  
	out	SPL,t1
	
   	ldi	t1,0b11100101  
	out	PORTB,t1        ; PB0=/, PB1=, PB2=,PB3=PB4=.  
	ldi	t1,0b11100101		
	out	DDRB,t1		    ; 
  
    ldi t1,(1<<TOIE0)   ;    
    out TIMSK0,t1         
	ldi t1,(1<<CS02)    ;     256  T0
    out TCCR0B,t1       ;    96000000/256 = 37500 Hz 
    ldi t1,Interval     ;  
    out TCNT0,t1 
ldi YH,0                ;      
ldi YL,$0064
ldi   Flg,$01       	;   0  ,  Ack	
    ldi Cnt,Nbyte       ;  6   
	clr DPtr
	ldi Cnt1,20         ;   2,0 
	sts SW4,Cnt1
    ldi t1,10
    mov Cnt2,t1
	sts SW5,Cnt2
	wdr
ldi	t1,(1<<WDCE)|(1<<WDE)
out	WDTCR,t1			;  
ldi	t1,(1<<WDE);|(1<<WDP1)
out	WDTCR,t1		; :   
					;  (wdr)   16 
					;    
					; RESET
   ; rjmp Main      ; ,    
ldi t1,15	 
sts SW0,t1
ldi t1,20
sts SW1,t1
ldi t1,14
sts SW2,t1
ldi t1,14
sts SW3,t1      ;  FrEE - 
rcall Code_8    ;       
sei
	rjmp Main 


;***************************************************************************

Wait5us:	;   5   f = 9,6 
ldi   time,13
W5:
dec   time	; 13 x 3  + 2nop + rcall + ret
brne  W5	;   = 48 
nop
nop
ret

Wait4us:	;   4   f = 9,6 
ldi   time,10;
W4:
dec   time	; 10 x 3  + nop + rcall + ret
brne  W4	;   = 38 
ret

;****************************************************************************
Start:				
sbi DDRB,SDA	; SDA = 0:  
rcall wait4us	;  

WriteByte:	;     
sec	            ;   C = 1
rol   dbyt	    ;  , C->LSB, MSB->C
rjmp  bit1	    ;    1
WriteBit:
lsl   dbyt	;  dbyt , ...
bit1:
breq  GetAck	; ...   
sbi DDRB,SCL	;   SCL
brcc  WriteLow	; ,   C = 0
nop	            ;    
cbi DDRB,SDA	;  SDA  1
rjmp  SCL_High
WriteLow:
sbi DDRB,SDA	;  SDA  0
rjmp  SCL_High	;    
SCL_High:
rcall wait4us	;  
cbi DDRB,SCL	;   SCL
WB1:
sbis  PinB,SCL	;     ?
rjmp  WB1
rcall wait5us	;  
rjmp  WriteBit

GetAck:	;     
sbi DDRB,SCL	;   SCL
cbi DDRB,SDA	; SDA   
rcall wait5us	;  
cbi DDRB,SCL	;   SCL
GA1:
sbis  PinB,SCL	;     
rjmp  GA1
cbr   Flg,1<<Ack	;  Ack = 0
sbic  PinB,SDA	;  SDA = 1,
sbr   Flg,1<<Ack	;  Ack = 1
rcall wait4us	;  
ret

;*********************************************************************************
Main: ;  

cpi Cnt1,0
breq Main1
rjmp Main
Main1:
lds Cnt1,SW4
dec Cnt2
brne Main
lds Cnt1,SW4
lds Cnt2,SW5
rcall Read_SPI  ;     
rjmp Main

;**********************************************************************************
Timer_Int0:  ;    0,  

    wdr	                 ;   
    in Save,SREG         ;    
    ldi t1,Interval      ;  
    out TCNT0,t1  
    ldi xl,Low(D0)       ;  SRAM - 
    ldi xh,High(D0)
    add xl,DPtr     ;       
ldi   dbyt,PCF_Adr	;  PCF8574,  - 
rcall Start	        ;    +  
sbrc  Flg,Ack   	;   ,  
ret	                ; ,   
ldi dbyt,$FF        ;  
rcall WriteByte	    ;  
sbrc  Flg,Ack   	;   ,  
ret	                ; ,   
rcall WrData164		;  0   164
ld dbyt,x           ;     SRAM - 
rcall WriteByte	    ;  
sbrc  Flg,Ack   	;   ,  
ret	                ; ,   
sbi DDRB,SCL	    ;   SCL
sbi DDRB,SDA		;  SDA  0
rcall wait5us		;  
cbi DDRB,SCL		;   SCL
rcall wait5us		;  
cbi DDRB,SDA		;  SDA  1
rcall wait5us		;  
	inc DPtr             ;   
    cpi DPtr,4           ;    
	breq TI0             ; ,  DPtr = 4
    out SREG,Save        ;    
  	reti
TI0:
    clr DPtr             ;     
	dec Cnt1             ;   1
    out SREG,Save        ;    
    reti

WrData164: ;  0   164

cpi DPtr,0
breq WR0
cbi PORTB,2   ;  1  ,  CLK
nop
sbi PORTB,0   ;  1   0,  A  164
nop
sbi PORTB,2 
ret
WR0:
cbi PORTB,2   ;  0  ,  CLK
nop   
cbi PORTB,0   ;  0   0,  A  164
nop   
sbi PORTB,2   
nop
sbi PORTB,0   ;  1   0,  A  164 
ret

Read_SPI: ;     

ldi t1,0b00000111;   
out DDRB,t1
nop  
nop
ldi t1,0b00000100
out DDRB,t1

RC0:
ldi   Byte_SPI,1;     
RC1:
sbis  PinB,SCK	;     ?
rjmp  RC1
nop
RC2:
sbic  PinB,SCK	;     ?
rjmp  RC2
clc	            ;  C = 0
sbic  PinB,SDI	;  SDI = 1
sec	            ;  C = 1
rol   Byte_SPI 	;     
brcc  RC1   	; ,    
st Y+,Byte_SPI  ;     
dec Cnt
brne RC0        ; ,  Cnt  0
RC3:
ldi YH,0        ;      
ldi YL,$0064
ldi Cnt,Nbyte   ;     
rcall Code_8    ;       
sbi DDRB,SDI    ;    
ret        

;****************************************************************************

SYMBOL:    ;     

S0_1: .db 0b11000000, 0b11111001   ; 0,1                              
S2_3: .db 0b10100100, 0b10110000   ; 2,3                              
S4_5: .db 0b10011001, 0b10010010   ; 4,5                              
S6_7: .db 0b10000010, 0b11111000   ; 6,7                              
S8_9: .db 0b10000000, 0b10010000   ; 8,9                              
SA_b: .db 0b10001000, 0b10000011   ; A,b -10,11                             
SC_d: .db 0b11000110, 0b10100001   ; C,d -12,13
SE_F: .db 0b10000110, 0b10001110   ; E,F -14,15
SU_P: .db 0b11000001, 0b10001100   ; U,P -16,17
SL_H: .db 0b11000111, 0b10001001   ; L,H -18,19
Sr_n: .db 0b10101111, 0b10101011   ; r,n -20,21
So_t: .db 0b10100011, 0b10000111   ; o,t -22,23
Sm_g: .db 0b10111111, 0b10011100   ; "-", "  " -24,25
Sp_b: .db 0b01111111, 0b11111111   ; ".", "Blank" -   -26,27
Sc_Pi: .db 0b10100111, 0b11001000 ; "c","" -28,29
Su_Y: .db 0b11100011, 0b10010001 ; "u","Y" -30,31
S__i: .db 0b11110111, 0b11011111 ; "_","i" -32,33
;******************************************************************************
ConvSegm:     ;      

ldi zl,Low(SYMBOL<<1)  ;    Z 
ldi zh,High(SYMBOL<<1) ;    
clr t3
add zl,t2              ;  BCD-,     
adc zh,t3
lpm                    ;   -  r0
ret 

Code_8:     ;       
         
lds t2,SW0        ;       ***1  ***
sbrc t2,7         ;   = 0
rjmp CD0          ;   = 1
rcall ConvSegm    ;  
sts D3,r0         ;   ,  
rjmp CE0
CD0:
andi t2,$7F       ;   
rcall ConvSegm    ;  
mov t2,r0
andi t2,$7F       ;   
sts D3,t2         ;   ,  
CE0: 
lds t2,SW1        ;    
sbrc t2,7         ;   = 0
rjmp CD1          ;   = 1
rcall ConvSegm    ;  
sts D2,r0         ;   ,  
rjmp CE1
CD1:
andi t2,$7F       ;   
rcall ConvSegm    ;  
mov t2,r0
andi t2,$7F       ;   
sts D2,t2         ;   ,  
CE1: 
lds t2,SW2        ;    
sbrc t2,7         ;   = 0
rjmp CD2          ;   = 1
rcall ConvSegm    ;  
sts D1,r0         ;   ,  
rjmp CE2
CD2:
andi t2,$7F       ;   
rcall ConvSegm    ;  
mov t2,r0
andi t2,$7F       ;   
sts D1,t2         ;   ,  
CE2: 
lds t2,SW3        ;    
sbrc t2,7         ;   = 0
rjmp CD3          ;   = 1
rcall ConvSegm    ;  
sts D0,r0         ;   ,  
rjmp CE3
CD3:
andi t2,$7F       ;   
rcall ConvSegm    ;  
mov t2,r0
andi t2,$7F       ;   
sts D0,t2         ;   ,  
CE3: 
ret
             
;**********************************************************************************
.dseg
  
D0: .byte 1   ;    4  , D0
D1: .byte 1   ;    3  , D1
D2: .byte 1   ;    2  , D2
D3: .byte 1   ;    1  , D3

SW0: .byte 1   ;  1- 
SW1: .byte 1   ;  2- 
SW2: .byte 1   ;  3- 
SW3: .byte 1   ;  4- 
SW4: .byte 1   ;      1
SW5: .byte 1   ;      2

;********************************************************************************
.Exit



