
;*********      *********** 
;*
;*  AVR ATtiny13A,   9,6 
;*  I2C,   100  
;*   DS18B20
;*
;* ; 
;*
;* Main:   
;* Timer_Int0:     0,  
;* WrData164:     0   164
;* Thermometer:       DS18B20
;* ConvTemp:       
;* ReadTemp:      
;* SignTemp:      
;* ConvByte:       , DS18B20
;* ConvByteD:          
;* CalcTemp:        
;* MUL42:         
;* DIV42:         
;* HexBCD:	     xx (Hex) -> 0abc (BCD)
;* Microlan:       1-Wire
;* SYMBOL:           
;* ConvSegm:          
;* Code_8:             
;* 
;* FUSES;          ()
;*************************************************************************

.nolist
.include "tn13def.inc"
.list

;*****  *****

.def   m0  = r1 
.def   m1  = r2
.def   m2  = r3
.def   m3  = r4 
.def   m4  = r5
.def   m5  = r6
.def   m6  = r7
.def   m7  = r8

.def	Save = r12     ;   SREG  
.def    Cnt2 = r13     ;  2,    
.def   hexL  = r14     ;   16- 
.def   hexH  = r15     ;   16- 
.def	t1	 = r16     ;   
.def	t2	 = r17     ;   
.def	dbyt = r18     ;       I2C
.def	Flg =  r19     ;  
.def	DPtr = r20     ;    
.def    Cnt1 = r21     ;  1,    
.def	BCD0  = r22    ;   - 
.def	tim1 = r23     ;   
.def	time = r24     ;   
.def    Cnt = r25      ;    
             

;*****   *****

.equ	Interval= 163   ;    T0,  400 
.equ    DQ =  PB1       ; DQ =  B,  1-Wire
.equ    SCL = PB3       ; SCL =  B,  I2C
.equ    SDA = PB4       ; SDA =  B
.equ    TimeT1=126      ;      (10 )
.equ    TimeT2=8
.equ    PCF_Adr = $40   ;  PCF8574T/3

;    Flg: 

.equ	Ack   = 0	    ;   =  0

.cseg

.org 0
    rjmp Initial
 
.org 3                   ;    T0, 
	rjmp Timer_Int0      
    
Initial:	
	
	ldi	t1,(RAMEND)	    ;  
	out	SPL,t1
	
   	ldi	t1,0b11100101  
	out	PORTB,t1        ; PB0=/,PB2=,PB1=PB3=PB4=.  
	ldi	t1,0b11100101		
	out	DDRB,t1		    ; 

    ldi t1,(1<<TOIE0)   ;     T0
    out TIMSK0,t1         
	ldi t1,(1<<CS02)    ;     256  T0
    out TCCR0B,t1       ;    96000000/256 = 37500 Hz 
    ldi t1,Interval     ;  
    out TCNT0,t1 

    ldi   Flg,$01    	;   0  ,  Ack	
    clr DPtr
    ldi Cnt1,TimeT1     ;       
    ldi t1,TimeT2
    mov Cnt2,t1

ldi Cnt,12	 
sts SW0,Cnt
ldi Cnt,10
sts SW1,Cnt
ldi Cnt,17
sts SW2,Cnt
ldi Cnt,10
sts SW3,Cnt
rcall Code_8       ;       
sei
	rjmp Main 


;***************************************************************************

Wait5us:	;   5   f = 9,6 
ldi   time,13
W5:
dec   time	; 13 x 3  + 2nop + rcall + ret
brne  W5	;   = 48 
nop
nop
ret

Wait4us:	;   4   f = 9,6 
ldi   time,10;
W4:
dec   time	; 10 x 3  + nop + rcall + ret
brne  W4	;   = 38 
ret

;****************************************************************************
Start:				
sbi DDRB,SDA	; SDA = 0:  
rcall wait4us	;  

WriteByte:	;     
sec	            ;   C = 1
rol   dbyt	    ;  , C->LSB, MSB->C
rjmp  bit1	    ;    1
WriteBit:
lsl   dbyt	;  dbyt , ...
bit1:
breq  GetAck	; ...   
sbi DDRB,SCL	;   SCL
brcc  WriteLow	; ,   C = 0
nop	            ;    
cbi DDRB,SDA	;  SDA  1
rjmp  SCL_High
WriteLow:
sbi DDRB,SDA	;  SDA  0
rjmp  SCL_High	;    
SCL_High:
rcall wait4us	;  
cbi DDRB,SCL	;   SCL
WB1:
sbis  PinB,SCL	;     ?
rjmp  WB1
rcall wait5us	;  
rjmp  WriteBit

GetAck:	;     
sbi DDRB,SCL	;   SCL
cbi DDRB,SDA	; SDA   
rcall wait5us	;  
cbi DDRB,SCL	;   SCL
GA1:
sbis  PinB,SCL	;     
rjmp  GA1
cbr   Flg,1<<Ack	;  Ack = 0
sbic  PinB,SDA	;  SDA = 1,
sbr   Flg,1<<Ack	;    Ack = 1
rcall wait4us	;  
ret

;*********************************************************************************
Main: ;  

cpi Cnt1,0
breq Main1
rjmp Main
Main1:
ldi Cnt1,TimeT1
dec Cnt2
brne Main
ldi Cnt1,TimeT1
ldi t1,TimeT2
mov Cnt2,t1
rcall Thermometer   ;      DS18B20
rjmp Main
;**********************************************************************************
Timer_Int0:  ;    0,  

    in Save,SREG         ;    
    push t1
    ldi t1,Interval      ;  
    out TCNT0,t1  
    ldi xl,Low(D0)       ;  SRAM - 
    ldi xh,High(D0)
    add xl,DPtr     ;       
ldi   dbyt,PCF_Adr	;  PCF8574,  - 
rcall Start	        ;    +  
sbrc  Flg,Ack   	;   ,  
ret	                ; ,   
ldi dbyt,$FF        ;  
rcall WriteByte	    ;  
sbrc  Flg,Ack   	;   ,  
ret	                ; ,   
rcall WrData164		;  0   164
ld dbyt,x           ;     SRAM - 
rcall WriteByte	    ;  
sbrc  Flg,Ack   	;   ,  
ret	                ; ,   
sbi DDRB,SCL	    ;   SCL
sbi DDRB,SDA		;  SDA  0
rcall wait5us		;  
cbi DDRB,SCL		;   SCL
rcall wait5us		;  
cbi DDRB,SDA		;  SDA  1
rcall wait5us		;  
	inc DPtr             ;   
    cpi DPtr,4           ;    
	breq TI0             ; ,  DPtr = 4
    pop t1
    out SREG,Save        ;    
    reti
TI0:
    clr DPtr             ;    
    dec Cnt1             ;   1
	pop t1 
    out SREG,Save        ;    
	reti

WrData164: ;  0   164

cpi DPtr,0
breq WR0
cbi PORTB,2   ;  1  ,  CLK
nop
sbi PORTB,0   ;  1   0,  A  164
nop
sbi PORTB,2 
ret
WR0:
cbi PORTB,2   ;  0  ,  CLK
nop   
cbi PORTB,0   ;  0   0,  A  164
nop   
sbi PORTB,2   
nop
sbi PORTB,0   ;  1   0,  A  164 
ret
;****************************************************************************
Microlan:

Wait5_us:	    ;    = 9,6 
ldi   tim1,8	;  
Wait501:
dec   tim1
brne  Wait501
nop
nop
nop
ret

Wait65us:	    ;    = 9,6 
ldi   tim1,141	;  
Wait565:
dec   tim1
brne  Wait565
nop
nop
nop
ret
	 
WaitML:	        ;    = 9,6 
rcall wait5_us
dec   t2
brne  WaitML
ret

ResML:    ;   

sbi DDRB,DQ       ; '' 
ldi t2,108
rcall WaitML      ;  700 
cbi DDRB,1        ; '' 
rcall Wait65us    ;  65
sbic PINB,DQ      ;   1  B
rjmp RM0          ;   ,  0
ldi t2,77
rcall WaitML      ;  500 
sbis PINB,DQ      ;   1  B
rjmp RM1
        ;   
ret               
RM0: 
        ; Error code - ' '
ret
RM1: 
        ; Error code - '  '
ret

RdSlot:  ;  

sbi DDRB,DQ       ; '' 
nop
nop
nop
nop
nop
cbi DDRB,DQ       ; '' 
nop
nop
nop
nop
nop
ldi t2,2
rcall WaitML      ;  13 
sbis PINB,DQ      ;   1  B
rjmp RS0          ;  ,  1
sec               ;  , '1'
ldi t2,11
rcall WaitML      ;  60
ret
RS0:
clc               ;  , '0'
ldi t2,11
rcall WaitML      ;  60
ret

WrSlotL:  ;  '0'  

sbi DDRB,DQ       ; '' 
ldi t2,15
rcall WaitML      ;  80 
cbi DDRB,DQ       ; '' 
ret

WrSlotH:  ;  '1'  

sbi DDRB,DQ       ; '' 
rcall Wait5_us
cbi DDRB,DQ       ; '' 
ldi t2,14
rcall WaitML      ;  75 
ret

Wr8ML:    ;  

ldi t1,8          ;  
WM0:
ror hexH          ;      
brcs WM1          ; ,  C=1
rcall WrSlotL     ;  '0'  
rjmp WM2
WM1:
rcall WrSlotH     ;  '1'  
WM2:
dec t1
brne WM0          ; ,   
ret

Wr1ML:    ;  

in t1,SREG        ;   
sbrs t1,0
rjmp WM5          ; ,  C=0
rcall WrSlotH     ;  '1'  
ret
WM5:
rcall WrSlotL     ;  '0'  
ret

Rd8ML:    ;  

ldi t1,8          ;  
WM6:
rcall RdSlot      ;  
ror hexH          ;      
dec t1
brne WM6          ; ,            
ret

Rd1ML:    ;  

rcall RdSlot      ;  
ret

;**********************************************************************************
Thermometer:   ;      DS18B20

ldi t1,0           ;    
out TIMSK0,t1 
rcall ConvTemp     ;  
rcall ReadTemp     ;  
rcall SignTemp     ;  
rcall ConvByte     ;   , DS18B20
rcall CalcTemp     ;    
rcall HexBCD       ;   BCD- ,   
rcall ConvByteD    ;   
rcall Code_8       ;       
ldi t1,(1<<TOIE0)  ;    
out TIMSK0,t1 
ret

ConvTemp:  ;   

rcall ResML       ;    
ldi t1,$CC
mov hexH,t1       ;  
rcall Wr8ML       ;  
ldi t1,$44
mov hexH,t1       ;  
rcall Wr8ML       ;  
WD3:
rcall Rd1ML       ;  
brcs WD4          ; ,  C=1
rjmp WD3          ;    
WD4:
ret

ReadTemp:  ;  

rcall ResML       ;    
ldi t1,$CC
mov hexH,t1       ;  
rcall Wr8ML       ;  
ldi t1,$BE        ;   
mov hexH,t1
rcall Wr8ML       ;  
rcall Rd8ML       ;   
mov hexL,hexH     ;   
rcall Rd8ML       ;   
ret

SignTemp:   ;  

mov t2,hexL     ;   
mov t1,hexH
bst  t1,7       ;     
brtc PosPlus0   ; ,   
com  t1         ;   
neg  t2         ;   
mov hexL,t2     ;   
mov hexH,t1
ldi t1,24       ;  '-',  
sts  SW0,t1
ret
PosPlus0:
ldi t1,27       ; 'Blank',  
sts  SW0,t1
ret

ConvByte:  ;   , DS18B20

mov t1,hexL       ;   
mov t2,hexH       ;   
swap t2           ;   
andi t2,$F0       ;   
swap t1           ;   
andi t1,$0F       ;   
or t2,t1          ;  
mov hexH,t2       ;   
mov t1,hexL
andi t1,$0F       ;    
mov hexL,t1       ;   
ret

ConvByteD:  ;       

mov t2,BCD0         ;   
andi BCD0,$F0       ;  
swap BCD0           ;   
cpi BCD0,0          ;  0
breq CB0
rjmp CB1            ;  > 0
CB0:
ldi t1,26           ;    ""
sts SW1,t1
rjmp CB2
CB1:
sts SW1,BCD0        ;     , 
CB2: 
andi t2,$0F         ;  
ldi t1,$80          ;    1
or  t2,t1           ;      
sts SW2,t2          ;     ,  
ret

CalcTemp:   ;    

mov m0,hexL        ;   
ldi t1,0
mov m1,t1
ldi t1,$71         ;   625 = $271 = 0,0625*10000
mov m2,t1
ldi t1,2
mov m3,t1
ldi t1,0           ;        
mov m4,t1
mov m5,t1
mov m6,t1
mov m7,t1

rcall MUL42

ldi t1,$E8         ;   1000 = $3E8
mov m0,t1             
ldi t1,3
mov m1,t1

rcall DIV42

sts SW3,m4        ;     
ret

MUL42:          ;  
ldi  t1,0x10
MUL1:               ; , m3:m2 * m1:m0
mov  t2,m2          ;   m7:m6:m5:m4
ror  t2           
brcc  MUL2        
mov  t2,m6
add  t2,m0
mov  m6,t2
mov  t2,m7
adc  t2,m1
mov  m7,t2
MUL2:
mov  t2,m7
ror  t2
mov  m7,t2
mov  t2,m6
ror  t2
mov  m6,t2
mov  t2,m5
ror  t2
mov  m5,t2
mov  t2,m4
ror  t2
mov  m4,t2
mov  t2,m3
ror  t2
mov  m3,t2
mov  t2,m2
ror  t2
mov  m2,t2
dec  t1
cpi  t1,0
brne MUL1
ret

DIV42:        ;  
ldi  t1,0x10
DCLK42:             ;   m7:m6:m5:m4
clc                 ;   m1:m0
mov  t2,m4          ;   m5:m4
rol  t2
mov  m4,t2
mov  t2,m5
rol  t2
mov  m5,t2
mov  t2,m6
rol  t2
mov  m6,t2
mov  t2,m7
rol  t2
mov  m7,t2
in   Cnt,SREG
push Cnt
PER1:
clc
mov  t2,m6
sbc  t2,m0
mov  m6,t2
mov  t2,m7
sbc  t2,m1
mov  m7,t2
brcs PER2
pop  Cnt
out  SREG,Cnt
PER3:
inc m4
rjmp PER4
PER2:
pop  Cnt
out  SREG,Cnt
brcs PER3
mov  t2,m6
add  t2,m0
mov  m6,t2
mov  t2,m7
adc  t2,m1
mov  m7,t2
PER4:
dec  t1
cpi  t1,0
brne DCLK42
ret
;****************************************************************************
HexBCD:	        ; xx (Hex) -> 0abc (BCD)
rcall Div10	    ; hexH / 10, -  tmp1
mov   BCD0,t1	;   hexH, tmp1 =  1
rcall Div10
swap  t1      ;  2   
or    BCD0,t1 ;   2  1  BCD0
ret

Div10:	
clr  t1
lsl  hexH
rol  t1	    ;     10  
ldi  Cnt,7	    ;   7 
Loop10:
lsl  hexH	    ;     1 
rol  t1	    ;   tmp1
subi t1,10	; ;  > 10 ?
brlo HB1	    ; ,  
inc  hexH       ;    1
rjmp HB2
HB1:
subi t1,-10	;   
HB2:
dec  Cnt	    ;   
brne Loop10	
ret 
;****************************************************************************

SYMBOL:    ;     

S0_1: .db 0b11000000, 0b11111001   ; 0,1                              
S2_3: .db 0b10100100, 0b10110000   ; 2,3                              
S4_5: .db 0b10011001, 0b10010010   ; 4,5                              
S6_7: .db 0b10000010, 0b11111000   ; 6,7                              
S8_9: .db 0b10000000, 0b10010000   ; 8,9                              
SA_b: .db 0b10001000, 0b10000011   ; A,b -10,11                             
SC_d: .db 0b11000110, 0b10100001   ; C,d -12,13
SE_F: .db 0b10000110, 0b10001110   ; E,F -14,15
SU_P: .db 0b11000001, 0b10001100   ; U,P -16,17
SL_H: .db 0b11000111, 0b10001001   ; L,H -18,19
Sr_n: .db 0b10101111, 0b10101011   ; r,n -20,21
So_t: .db 0b10100011, 0b10000111   ; o,t -22,23
Sm_g: .db 0b10111111, 0b10011100   ; "-", "  " -24,25
Sp_b: .db 0b01111111, 0b11111111   ; ".", "Blank" -   -26,27
Sc_Pi: .db 0b10100111, 0b11001000 ; "c","" -28,29
Su_Y: .db 0b11100011, 0b10010001 ; "u","Y" -30,31
S__i: .db 0b11110111, 0b11011111 ; "_","i" -32,33
;******************************************************************************
ConvSegm:     ;      

ldi zl,Low(SYMBOL<<1)  ;    Z 
ldi zh,High(SYMBOL<<1) ;    
clr t1
add zl,t2           ;   ,     
adc zh,t1
lpm                    ;    -  r0
ret 

Code_8:     ;       
         
lds t2,SW0        ;       ***1  ***
sbrc t2,7         ;   = 0
rjmp CD0          ;   = 1
rcall ConvSegm    ;  
sts D3,r0         ;   ,  
rjmp CE0
CD0:
andi t2,$7F       ;   
rcall ConvSegm    ;  
mov t2,r0
andi t2,$7F       ;   
sts D3,t2         ;   ,  
CE0: 
lds t2,SW1        ;    
sbrc t2,7         ;   = 0
rjmp CD1          ;   = 1
rcall ConvSegm    ;  
sts D2,r0         ;   ,  
rjmp CE1
CD1:
andi t2,$7F       ;   
rcall ConvSegm    ;  
mov t2,r0
andi t2,$7F       ;   
sts D2,t2         ;   ,  
CE1: 
lds t2,SW2        ;    
sbrc t2,7         ;   = 0
rjmp CD2          ;   = 1
rcall ConvSegm    ;  
sts D1,r0         ;   ,  
rjmp CE2
CD2:
andi t2,$7F       ;   
rcall ConvSegm    ;  
mov t2,r0
andi t2,$7F       ;   
sts D1,t2         ;   ,  
CE2: 
lds t2,SW3        ;    
sbrc t2,7         ;   = 0
rjmp CD3          ;   = 1
rcall ConvSegm    ;  
sts D0,r0         ;   ,  
rjmp CE3
CD3:
andi t2,$7F       ;   
rcall ConvSegm    ;  
mov t2,r0
andi t2,$7F       ;   
sts D0,t2         ;   ,  
CE3: 
ret
             
;**********************************************************************************
.dseg
  
D0: .byte 1   ;    4  , D0
D1: .byte 1   ;    3  , D1
D2: .byte 1   ;    2  , D2
D3: .byte 1   ;    1  , D3

SW0: .byte 1   ;  1- 
SW1: .byte 1   ;  2- 
SW2: .byte 1   ;  3- 
SW3: .byte 1   ;  4- 


;********************************************************************************
.Exit




