;*********      *********** 
;*
;*  AVR ATtiny13A,   9,6 
;*  I2C,   100  
;*    MK41T56
;*
;* ; 
;*
;* Main:   
;* Timer_Int0:     0,  
;* WrData164:     0   164
;* RTC:              MK41T56
;* ReadTime:         MK41T56
;* WriteTime:        MK41T56
;* ConvTime:          
;* StartTime:     MK41T56
;* SYMBOL:           
;* ConvSegm:          
;* Code_8:             
;* 
;* FUSES;          ()
;*************************************************************************

.nolist
.include "tn13def.inc"
.list

;*****  *****

.def	Save = r12     ;   SREG  

.def	t1	 = r16     ;   
.def	t2	 = r17     ;   
.def	dbyt = r18     ;       I2C
.def	Flg =  r19     ;  
.def	DPtr = r20     ;    
.def    Cnt1 = r21     ;  1,    RTC
.def   Minutes = r22   ;  
.def   Hours = r23     ;  
.def	time = r24     ;   
.def    Cnt2 = r25     ;  2,    RTC  
 
;*****   *****

.equ	Interval= 163   ;    T0,  400 
.equ    SCL = PB3       ; SCL =  B,  I2C
.equ    SDA = PB4       ; SDA =  B
.equ    TimeT1 = 11     ;     RTC (1,0 )
.equ    TimeT2 = 10
.equ    TimeT2_2 = 5
.equ    PCF_Adr = $40   ;  PCF8574T/3
.equ    RTC_Adr = $D0   ;  MK41T56

;    Flg: 

.equ	Ack   = 0	    ;   =  0

.cseg

.org 0
    rjmp Initial
 
.org 3                   ;    T0, 
	rjmp Timer_Int0      
    
Initial:	
	
	ldi	t1,(RAMEND)	    ;  
	out	SPL,t1
	
   	ldi	t1,0b11100111  
	out	PORTB,t1        ; PB0=/,PB2=,PB1= ,PB3=PB4=.  
	ldi	t1,0b11100101		
	out	DDRB,t1		    ; 

    ldi t1,(1<<TOIE0)   ;     T0
    out TIMSK0,t1         
	ldi t1,(1<<CS02)    ;     256  T0
    out TCCR0B,t1       ;    96000000/256 = 37500 Hz 
    ldi t1,Interval     ;  
    out TCNT0,t1 

ldi   Flg,$01			;   0  ,  Ack	
    clr DPtr
    ldi Cnt1,TimeT1     ;       
    clr Cnt2
clr  t1
in  t1,PINB         	;    SB1
sbrc t1,1         		;   ,   
rjmp IN0
ldi Hours,0x18			; 18 , (- )
ldi Minutes,0			; 00 

rcall WriteTime	   		;     MK41T56
rcall StartTime			;  MK41T56
IN0:
ldi t1,12	 
sts SW0,t1
ldi t1,10
sts SW1,t1
ldi t1,17
sts SW2,t1
ldi t1,10
sts SW3,t1
rcall Code_8       ;       
sei
	rjmp Main 


;***************************************************************************

Wait5us:	;   5   f = 9,6 
ldi   time,13
W5:
dec   time	; 13 x 3  + 2nop + rcall + ret
brne  W5	;   = 48 
nop
nop
ret

Wait4us:	;   4   f = 9,6 
ldi   time,10;
W4:
dec   time	; 10 x 3  + nop + rcall + ret
brne  W4	;   = 38 
ret

;****************************************************************************
ReStart:	;   
sbi DDRB,SCL	;   SCL
nop
cbi DDRB,SDA	;  SDA  1
nop
rcall wait5us	;  
nop
cbi DDRB,SCL	;   SCL
RS1:
sbis  PinB,SCL	;     ?
rjmp  RS1
rcall wait5us	;  

Start:				
sbi DDRB,SDA	; SDA = 0:  
rcall wait4us	;  

WriteByte:	;     
sec	            ;   C = 1
rol   dbyt	    ;  , C->LSB, MSB->C
rjmp  bit1	    ;    1
WriteBit:
lsl   dbyt	;  dbyt , ...
bit1:
breq  GetAck	; ...   
sbi DDRB,SCL	;   SCL
brcc  WriteLow	; ,   C = 0
nop	            ;    
cbi DDRB,SDA	;  SDA  1
rjmp  SCL_High
WriteLow:
sbi DDRB,SDA	;  SDA  0
rjmp  SCL_High	;    
SCL_High:
rcall wait4us	;  
cbi DDRB,SCL	;   SCL
WB1:
sbis  PinB,SCL	;     ?
rjmp  WB1
rcall wait5us	;  
rjmp  WriteBit

GetAck:	;     
sbi DDRB,SCL	;   SCL
cbi DDRB,SDA	; SDA   
rcall wait5us	;  
cbi DDRB,SCL	;   SCL
GA1:
sbis  PinB,SCL	;     
rjmp  GA1
cbr   Flg,1<<Ack	;  Ack = 0
sbic  PinB,SDA	;  SDA = 1,
sbr   Flg,1<<Ack	;    Ack = 1
rcall wait4us	;  
ret

ReadByte:
ldi   dbyt,1	;     
RB1:
sbi DDRB,SCL	;   SCL
rcall wait5us	;  
cbi DDRB,SCL	;   SCL
RB2:
sbis  PinB,SCL	;     ?
rjmp  RB2
rcall wait5us	;  
clc	;  C = 0
sbic  PinB,SDA	;  SDA = 1
sec	;   Carry = 1
rol   dbyt	;     
brcc  RB1	; ,    

SetAck:	;   
sbi DDRB,SCL	;   SCL
sbrs  Flg,Ack	;   ,  Ack=1
rjmp  SA1	; ,  Ack = 0
cbi DDRB,SDA	;  SDA  1
rjmp  SA2
SA1:
sbi DDRB,SDA	; SDA = 0
SA2:
rcall wait5us	;  
cbi DDRB,SCL	;   SCL
SA3:
sbis PinB,SCL	;     ?
rjmp  SA3
sbi DDRB,SCL
nop
cbi DDRB,SDA
rcall wait5us
ret

Stopp:	;   
sbi DDRB,SCL	;   SCL
sbi DDRB,SDA	;  SDA  0
rcall wait5us	;  
cbi DDRB,SCL	;   SCL
rcall wait5us	;  
cbi DDRB,SDA	;  SDA  1
rcall wait5us	;  
ret
;*********************************************************************************
Main: ;  

cpi Cnt1,0
breq Main1
rjmp Main
Main1:
ldi Cnt1,TimeT1 
inc Cnt2
cpi Cnt2,TimeT2_2
breq Main2
rjmp Main
Main2:
rcall RTC   ;       MK41T56
Main3:
cpi Cnt1,0
breq Main4
rjmp Main3
Main4:
ldi Cnt1,TimeT1 
inc Cnt2
cpi Cnt2,TimeT2
breq Main5
rjmp Main3
Main5:
ldi Cnt1,TimeT1
clr Cnt2
rcall RTC   ;       MK41T56
rjmp Main
;**********************************************************************************
Timer_Int0:  ;    0,  

    in Save,SREG         ;    
    push t1
    ldi t1,Interval      ;  
    out TCNT0,t1  
    ldi xl,Low(D0)       ;  SRAM - 
    ldi xh,High(D0)
    add xl,DPtr     ;       
ldi   dbyt,PCF_Adr	;  PCF8574,  - 
rcall Start	        ;    +  
sbrc  Flg,Ack   	;   ,  
ret	                ; ,   
ldi dbyt,$FF        ;  
rcall WriteByte	    ;  
sbrc  Flg,Ack   	;   ,  
ret	                ; ,   
rcall WrData164		;  0   164
ld dbyt,x           ;     SRAM - 
rcall WriteByte	    ;  
sbrc  Flg,Ack   	;   ,  
ret	                ; ,   
sbi DDRB,SCL	    ;   SCL
sbi DDRB,SDA		;  SDA  0
rcall wait5us		;  
cbi DDRB,SCL		;   SCL
rcall wait5us		;  
cbi DDRB,SDA		;  SDA  1
rcall wait5us		;  
	inc DPtr             ;   
    cpi DPtr,4           ;    
	breq TI0             ; ,  DPtr = 4
    pop t1
    out SREG,Save        ;    
    reti
TI0:
    clr DPtr             ;    
    dec Cnt1             ;   1
	pop t1 
    out SREG,Save        ;    
	reti

WrData164: ;  0   164

cpi DPtr,0
breq WR0
cbi PORTB,2   ;  1  ,  CLK
nop
sbi PORTB,0   ;  1   0,  A  164
nop
sbi PORTB,2 
ret
WR0:
cbi PORTB,2   ;  0  ,  CLK
nop   
cbi PORTB,0   ;  0   0,  A  164
nop   
sbi PORTB,2   
nop
sbi PORTB,0   ;  1   0,  A  164 
ret
;****************************************************************************

RTC: ;   
 
rcall ReadTime	;     MK41T56
rcall ConvTime  ;       
rcall Code_8    ;       
ret

 
ReadTime:	;     MK41T56

ldi   dbyt,RTC_Adr	;  MK41T56,  - 
rcall Start			;    +  
sbrc  Flg,Ack		;   ,  
ret	                ; ,   
ldi   dbyt,$01	    ;  
rcall WriteByte	    ; 
sbrc  Flg,Ack       ;   ,  
ret	                ; ,   
ldi   dbyt,RTC_Adr+1;  MK41T56,  - 
rcall ReStart		;     + 
sbrc  Flg,Ack		;   ,    = 0
ret					; ,   
rcall ReadByte		;  ,   = 0
sts SD0,dbyt	    ;     
sbr   Flg,1<<Ack	;  
rcall ReadByte		;  ,   = 1
sts SD1,dbyt		;     
rcall stopp			;   
ret

WriteTime:	;     MK41T56

ldi   dbyt,RTC_Adr	;  MK41T56,  - 
rcall Start			;    +  
sbrc  Flg,Ack		;   ,  
ret					; ,   
ldi   dbyt,0		;    
rcall WriteByte		; 
sbrc  Flg,Ack		;   ,  
ret					; ,   
ldi   dbyt,$80		;  
rcall WriteByte		; 
sbrc  Flg,Ack		;   ,  
ret
mov   dbyt,Minutes	;  , 
rcall WriteByte		; 
sbrc  Flg,Ack		;   ,  
ret
mov   dbyt,Hours	;  , 
rcall WriteByte		; 
sbrc  Flg,Ack		;   ,  
ret
ldi   dbyt,5		;  ()
rcall WriteByte		; 
sbrc  Flg,Ack		;   ,  
ret
ldi   dbyt,39		;  (27)
rcall WriteByte		; 
sbrc  Flg,Ack		;   ,  
ret
ldi   dbyt,6		;  ()
rcall WriteByte		; 
sbrc  Flg,Ack		;   ,  
ret
ldi   dbyt,20		; , (2014)
rcall WriteByte		; 
sbrc  Flg,Ack		;   ,  
ret
rcall stopp			;   
ret

StartTime:	;  MK41T56

ldi   dbyt,RTC_Adr	;  MK41T56,  - 
rcall Start			;    +  
sbrc  Flg,Ack		;   ,  
ret					; ,   
ldi   dbyt,0		;    
rcall WriteByte		; 
sbrc  Flg,Ack		;   ,  
ret					; ,   
ldi   dbyt,0		;  
rcall WriteByte		; 
sbrc  Flg,Ack		;   ,  
ret
rcall stopp			;   
ret

ConvTime: ;        

lds t1,SD1         ;    
mov t2,t1
andi t1,$F0
swap t1
cpi t1,0           ;  0
breq CT0
rjmp CT1           ;  > 0
CT0:
ldi t1,27          ;    ""
sts SW0,t1
rjmp CT2
CT1:
sts SW0,t1         ;      
CT2:
cpi Cnt2,TimeT2_2
brsh CT2A
andi t2,$0F
ldi t1,$80
or t2,t1
sts SW1,t2         ;      , DP- 
rjmp CT2B
CT2A:
andi t2,$0F
sts SW1,t2         ;      , DP-
CT2B:
lds t1,SD0         ;    
mov t2,t1
andi t1,$F0
swap t1
sts SW2,t1         ;      
andi t2,$0F
sts SW3,t2         ;      
ret

;****************************************************************************

SYMBOL:    ;     

S0_1: .db 0b11000000, 0b11111001   ; 0,1                              
S2_3: .db 0b10100100, 0b10110000   ; 2,3                              
S4_5: .db 0b10011001, 0b10010010   ; 4,5                              
S6_7: .db 0b10000010, 0b11111000   ; 6,7                              
S8_9: .db 0b10000000, 0b10010000   ; 8,9                              
SA_b: .db 0b10001000, 0b10000011   ; A,b -10,11                             
SC_d: .db 0b11000110, 0b10100001   ; C,d -12,13
SE_F: .db 0b10000110, 0b10001110   ; E,F -14,15
SU_P: .db 0b11000001, 0b10001100   ; U,P -16,17
SL_H: .db 0b11000111, 0b10001001   ; L,H -18,19
Sr_n: .db 0b10101111, 0b10101011   ; r,n -20,21
So_t: .db 0b10100011, 0b10000111   ; o,t -22,23
Sm_g: .db 0b10111111, 0b10011100   ; "-", "  " -24,25
Sp_b: .db 0b01111111, 0b11111111   ; ".", "Blank" -   -26,27
Sc_Pi: .db 0b10100111, 0b11001000 ; "c","" -28,29
Su_Y: .db 0b11100011, 0b10010001 ; "u","Y" -30,31
S__i: .db 0b11110111, 0b11011111 ; "_","i" -32,33
;******************************************************************************
ConvSegm:     ;      

ldi zl,Low(SYMBOL<<1)  ;    Z 
ldi zh,High(SYMBOL<<1) ;    
clr t1
add zl,t2           ;   ,     
adc zh,t1
lpm                    ;    -  r0
ret 

Code_8:     ;       
         
lds t2,SW0        ;       ***1  ***
sbrc t2,7         ;   = 0
rjmp CD0          ;   = 1
rcall ConvSegm    ;  
sts D3,r0         ;   ,  
rjmp CE0
CD0:
andi t2,$7F       ;   
rcall ConvSegm    ;  
mov t2,r0
andi t2,$7F       ;   
sts D3,t2         ;   ,  
CE0: 
lds t2,SW1        ;    
sbrc t2,7         ;   = 0
rjmp CD1          ;   = 1
rcall ConvSegm    ;  
sts D2,r0         ;   ,  
rjmp CE1
CD1:
andi t2,$7F       ;   
rcall ConvSegm    ;  
mov t2,r0
andi t2,$7F       ;   
sts D2,t2         ;   ,  
CE1: 
lds t2,SW2        ;    
sbrc t2,7         ;   = 0
rjmp CD2          ;   = 1
rcall ConvSegm    ;  
sts D1,r0         ;   ,  
rjmp CE2
CD2:
andi t2,$7F       ;   
rcall ConvSegm    ;  
mov t2,r0
andi t2,$7F       ;   
sts D1,t2         ;   ,  
CE2: 
lds t2,SW3        ;    
sbrc t2,7         ;   = 0
rjmp CD3          ;   = 1
rcall ConvSegm    ;  
sts D0,r0         ;   ,  
rjmp CE3
CD3:
andi t2,$7F       ;   
rcall ConvSegm    ;  
mov t2,r0
andi t2,$7F       ;   
sts D0,t2         ;   ,  
CE3: 
ret
             
;**********************************************************************************
.dseg
  
D0: .byte 1   ;    4  , D0
D1: .byte 1   ;    3  , D1
D2: .byte 1   ;    2  , D2
D3: .byte 1   ;    1  , D3

SW0: .byte 1   ;  1- 
SW1: .byte 1   ;  2- 
SW2: .byte 1   ;  3- 
SW3: .byte 1   ;  4- 

SD0: .byte 1   ;  
SD1: .byte 1   ;  

;********************************************************************************
.Exit
